<template>
  <v-card>
    <v-card-title class="title">
      Task types
    </v-card-title>
    <v-row>
      <v-col cols="3">
        <v-list id="submission-types-list">
          <v-list-item
            v-for="submissionType in sortedSubmissionTypes"
            :key="submissionType.pk"
            @click="selectedSubmissionType = submissionType"
          >
            <v-list-item-content>
              {{ submissionType.name }}
            </v-list-item-content>
          </v-list-item>
        </v-list>
      </v-col>
      <v-col cols="9">
        <v-row
          v-if="!selectedSubmissionType"
          justify="center"
        >
          <strong>Select a task type on the left to see the description and solution.</strong>
        </v-row>
        <submission-type
          v-else
          :closeable="false"
          class="mr-2 mb-2"
          v-bind="selectedSubmissionType"
        />
      </v-col>
    </v-row>
  </v-card>
</template>

<script>
import SubmissionType from '@/components/submission_type/SubmissionType'
import { ConfigModule } from '../../store/modules/config'
import store from '@/store/store'

export default {
  name: 'SubmissionTypesOverview',
  components: { SubmissionType },
  data () {
    return {
      selectedSubmissionTypePk: null
    }
  },
  computed: {
    submissionTypes () {
      let types = Object.values(store.state.submissionTypes)
      return types.filter(submissionType => {
         return submissionType.examType.moduleReference === ConfigModule.state.config.currentExam
      })
    },
    // needed to keep selectedSubmissionType reactive
    selectedSubmissionType: {
      get: function () {
        return store.state.submissionTypes[this.selectedSubmissionTypePk]
      },
      set: function (newSubType) {
        this.selectedSubmissionTypePk = newSubType.pk
      }
    },
    sortedSubmissionTypes () {
      return Object.values(this.submissionTypes).sort((t1, t2) => {
        let lowerName1 = t1.name.toLowerCase()
        let lowerName2 = t2.name.toLowerCase()
        if (lowerName1 < lowerName2) {
          return -1
        } else if (lowerName1 > lowerName2) {
          return 1
        }
        return 0
      })
    }
  }
}
</script>

<style scoped>

</style>
